| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
AlgExecStateSvc Class Reference

A service that keeps track of the execution state of Algorithm *. More...

`#include <src/AlgExecStateSvc/AlgExecStateSvc.h>`

Inheritance diagram for AlgExecStateSvc:
[legend]
Collaboration diagram for AlgExecStateSvc:
[legend]

## Public Types
typedef IAlgExecStateSvc::AlgStateMap_t | AlgStateMap_t
Public Types inherited from extends< Service, IAlgExecStateSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...

## Public Member Functions
| AlgExecStateSvc (const std::string &name, ISvcLocator *svc)
| Constructor. More...
| ~AlgExecStateSvc ()
| Destructor. More...
virtual StatusCode | initialize () override final
virtual StatusCode | finalize () override final
const AlgExecState & | algExecState (const Gaudi::StringKey &algName, const EventContext &ctx) const override
const AlgExecState & | algExecState (IAlgorithm *iAlg, const EventContext &ctx) const override
AlgExecState & | algExecState (IAlgorithm *iAlg, const EventContext &ctx) override
const AlgStateMap_t & | algExecStates (const EventContext &ctx) const override
void | reset (const EventContext &ctx) override
void | addAlg (IAlgorithm *iAlg) override
void | addAlg (const Gaudi::StringKey &algName) override
const EventStatus::Status & | eventStatus (const EventContext &ctx) const override
void | setEventStatus (const EventStatus::Status &sc, const EventContext &ctx) override
void | updateEventStatus (const bool &b, const EventContext &ctx) override
unsigned int | algErrorCount (const IAlgorithm *iAlg) const override
void | resetErrorCount (const IAlgorithm *iAlg) override
unsigned int | incrementErrorCount (const IAlgorithm *iAlg) override
void | dump (std::ostringstream &ost, const EventContext &ctx) const override
Public Member Functions inherited from extends< Service, IAlgExecStateSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Types
typedef std::vector< AlgStateMap_t > | AlgStates_t
typedef std::map< Gaudi::StringKey, std::atomic< unsigned int > > | AlgErrorMap_t

## Private Member Functions
std::string | trans (const EventStatus::Status &sc) const
void | init ()
void | checkInit () const

## Private Attributes
AlgStates_t | m_algStates
std::vector< EventStatus::Status > | m_eventStatus
std::vector< Gaudi::StringKey > | m_preInitAlgs
AlgErrorMap_t | m_errorCount
std::once_flag | m_initFlag
bool | m_isInit
std::mutex | m_mut

## Additional Inherited Members
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

A service that keeps track of the execution state of Algorithm *.

Definition at line 18 of file AlgExecStateSvc.h.

## Member Typedef Documentation

typedef std::map< Gaudi::StringKey, std::atomic<unsigned int> > AlgExecStateSvc::AlgErrorMap_t
| private

Definition at line 69 of file AlgExecStateSvc.h.

typedef IAlgExecStateSvc::AlgStateMap_t AlgExecStateSvc::AlgStateMap_t

Definition at line 30 of file AlgExecStateSvc.h.

typedef std::vector< AlgStateMap_t > AlgExecStateSvc::AlgStates_t
| private

Definition at line 63 of file AlgExecStateSvc.h.

## Constructor & Destructor Documentation

AlgExecStateSvc::AlgExecStateSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Constructor.

Definition at line 15 of file AlgExecStateSvc.cpp.

15 :
16 base_class(name,svcLoc), m_isInit(false)
17 {
18
19 }
extends< Service, IAlgExecStateSvc >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
AlgExecStateSvc::m_isInit
bool m_isInit
Definition: AlgExecStateSvc.h:75

AlgExecStateSvc::~AlgExecStateSvc | ( |  | ) |

Destructor.

Definition at line 23 of file AlgExecStateSvc.cpp.

23 {
24
25 }

## Member Function Documentation

void AlgExecStateSvc::addAlg | ( | IAlgorithm * | iAlg | ) |
| override

Definition at line 154 of file AlgExecStateSvc.cpp.

154 {
155 return addAlg(iAlg->nameKey());
156 }
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.
AlgExecStateSvc::addAlg
void addAlg(IAlgorithm *iAlg) override
Definition: AlgExecStateSvc.cpp:154

void AlgExecStateSvc::addAlg | ( | const Gaudi::StringKey & | algName | ) |
| override

Definition at line 161 of file AlgExecStateSvc.cpp.

161 {
162
163
164 if (!m_isInit) {
165 if (msgLevel(MSG::DEBUG))
166 debug() << "preInit: will add Alg " << alg.str() << " later" << endmsg;
167 m_preInitAlgs.push_back( alg );
168 return;
169 }
170
171 if (m_algStates.size() > 0) {
172 if (m_algStates.at(0).find(alg) != m_algStates.at(0).end()) {
173 // already added
174 return;
175 }
176 }
177
178 {
179 // in theory, this should only get called during initialization (serial)
180 // so shouldn't have to protect with a mutex...
181 std::lock_guard<std::mutex> lock(m_mut);
182
183 AlgExecState s;
184 for (size_t i = 0; i<m_algStates.size(); ++i) {
185 m_algStates.at(i)[alg] = s;
186 }
187
188 m_errorCount[alg] = 0;
189
190 }
191
192 if (msgLevel(MSG::DEBUG))
193 debug() << "adding alg " << alg.str() << " to "
194 << m_algStates.size() << " slots" << endmsg;
195
196 }
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
MSG::DEBUG
Definition: IMessageSvc.h:18
std::map::end
T end(T...args)
std::vector::at
T at(T...args)
std::vector::push_back
T push_back(T...args)
AlgExecStateSvc::m_errorCount
AlgErrorMap_t m_errorCount
Definition: AlgExecStateSvc.h:70
std::lock
T lock(T...args)
AlgExecStateSvc::m_isInit
bool m_isInit
Definition: AlgExecStateSvc.h:75
AlgExecStateSvc::m_mut
std::mutex m_mut
Definition: AlgExecStateSvc.h:77
std::map::find
T find(T...args)
std::vector::size
T size(T...args)
std::lock_guard
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
gaudirun.s
string s
Definition: gaudirun.py:245
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
AlgExecState
Definition: IAlgExecStateSvc.h:27
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
AlgExecStateSvc::m_preInitAlgs
std::vector< Gaudi::StringKey > m_preInitAlgs
Definition: AlgExecStateSvc.h:67

unsigned int AlgExecStateSvc::algErrorCount | ( | const IAlgorithm * | iAlg | ) | const
| override

Definition at line 310 of file AlgExecStateSvc.cpp.

310 {
311 AlgErrorMap_t::const_iterator itr = m_errorCount.find( iAlg->nameKey() );
312
313 if (itr != m_errorCount.end()) {
314 return itr->second;
315 } else {
316 error() << "Unable to find Algorithm \"" << iAlg->name() << "\" in map"
317 << " of ErrorCounts" << endmsg;
318 return 0;
319 }
320 }
std::map::end
T end(T...args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
AlgExecStateSvc::m_errorCount
AlgErrorMap_t m_errorCount
Definition: AlgExecStateSvc.h:70
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.
std::map::find
T find(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

const AlgExecState & AlgExecStateSvc::algExecState | ( | const Gaudi::StringKey & | algName,
|  | const EventContext & | ctx
| ) |  | const
| override

Definition at line 201 of file AlgExecStateSvc.cpp.

202 {
203
204 checkInit();
205
206 AlgStateMap_t::const_iterator itr = m_algStates.at(ctx.slot()).find( algName );
207
208 if (UNLIKELY( itr == m_algStates.at(ctx.slot()).end() ) ) {
209 throw GaudiException{std::string{"cannot find Alg "}
210 + algName.str() + " in AlgStateMap", name(), StatusCode::FAILURE};
211 }
212
213 return itr->second;
214
215 }
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:23
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
StatusCode::FAILURE
Definition: StatusCode.h:29
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:126
std::string
STL class.
AlgExecStateSvc::checkInit
void checkInit() const
Definition: AlgExecStateSvc.cpp:91
std::vector::at
T at(T...args)
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:50
std::find
T find(T...args)
Gaudi::StringKey::str
const std::string & str() const
the actual string
Definition: StringKey.h:47

const AlgExecState & AlgExecStateSvc::algExecState | ( | IAlgorithm * | iAlg,
|  | const EventContext & | ctx
| ) |  | const
| override

Definition at line 220 of file AlgExecStateSvc.cpp.

221 {
222
223 return algExecState(iAlg->nameKey(), ctx);
224
225 }
AlgExecStateSvc::algExecState
const AlgExecState & algExecState(const Gaudi::StringKey &algName, const EventContext &ctx) const override
Definition: AlgExecStateSvc.cpp:201
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.

AlgExecState & AlgExecStateSvc::algExecState | ( | IAlgorithm * | iAlg,
|  | const EventContext & | ctx
| ) |  |
| override

Definition at line 230 of file AlgExecStateSvc.cpp.

231 {
232
233 std::call_once(m_initFlag, &AlgExecStateSvc::init, this);
234
235 AlgStateMap_t::iterator itr = m_algStates.at(ctx.slot()).find( iAlg->nameKey() );
236
237 if (UNLIKELY( itr == m_algStates.at(ctx.slot()).end() ) ) {
238 throw GaudiException{std::string{"cannot find Alg "}
239 + iAlg->name() + " in AlgStateMap", name(), StatusCode::FAILURE};
240 }
241
242 return itr->second;
243
244 }
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:23
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
StatusCode::FAILURE
Definition: StatusCode.h:29
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
AlgExecStateSvc::init
void init()
Definition: AlgExecStateSvc.cpp:30
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:126
AlgExecStateSvc::m_initFlag
std::once_flag m_initFlag
Definition: AlgExecStateSvc.h:74
std::call_once
T call_once(T...args)
std::string
STL class.
std::vector::at
T at(T...args)
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:50
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.
std::find
T find(T...args)

const IAlgExecStateSvc::AlgStateMap_t & AlgExecStateSvc::algExecStates | ( | const EventContext & | ctx | ) | const
| override

Definition at line 249 of file AlgExecStateSvc.cpp.

249 {
250
251 checkInit();
252
253 return m_algStates.at(ctx.slot());
254 }
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
AlgExecStateSvc::checkInit
void checkInit() const
Definition: AlgExecStateSvc.cpp:91
std::vector::at
T at(T...args)

void AlgExecStateSvc::checkInit | ( |  | ) | const
| private

Definition at line 91 of file AlgExecStateSvc.cpp.

91 {
92
93 if (!m_isInit) {
94 fatal() << "AlgExecStateSvc not initialized before first use" << endmsg;
95 throw GaudiException("AlgExecStateSvc not initialized before first use!",
96 "AlgExecStateSvc",StatusCode::FAILURE);
97 }
98 }
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:23
StatusCode::FAILURE
Definition: StatusCode.h:29
AlgExecStateSvc::m_isInit
bool m_isInit
Definition: AlgExecStateSvc.h:75
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:111
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void AlgExecStateSvc::dump | ( | std::ostringstream & | ost,
|  | const EventContext & | ctx
| ) |  | const
| override

Definition at line 130 of file AlgExecStateSvc.cpp.

130 {
131
132 ost << "Event: " << trans(m_eventStatus.at(ctx.slot())) << std::endl;
133 ost << "Algs: " << m_algStates.at(ctx.slot()).size() << std::endl;
134
135 size_t ml(0);
136 for (auto &e : m_algStates.at(ctx.slot())) {
137 if ( e.first.str().length() > ml ) {
138 ml = e.first.str().length();
139 }
140 }
141
142 ost << " - Slot " << ctx.slot() << std::endl;
143 const AlgStateMap_t& m = m_algStates.at(ctx.slot());
144 for (auto &e : m) {
145 ost << " + " << std::setw(ml) << e.first.str() << " " << e.second
146 << std::endl;
147 }
148
149 }
AlgExecStateSvc::AlgStateMap_t
IAlgExecStateSvc::AlgStateMap_t AlgStateMap_t
Definition: AlgExecStateSvc.h:30
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
std::endl
T endl(T...args)
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
std::setw
T setw(T...args)
std::vector::at
T at(T...args)
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:93
AlgExecStateSvc::trans
std::string trans(const EventStatus::Status &sc) const
Definition: AlgExecStateSvc.cpp:352

const EventStatus::Status & AlgExecStateSvc::eventStatus | ( | const EventContext & | ctx | ) | const
| override

Definition at line 259 of file AlgExecStateSvc.cpp.

259 {
260 checkInit();
261 return m_eventStatus.at(ctx.slot());
262 }
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
AlgExecStateSvc::checkInit
void checkInit() const
Definition: AlgExecStateSvc.cpp:91
std::vector::at
T at(T...args)

StatusCode AlgExecStateSvc::finalize | ( |  | ) |
| final override virtual

Definition at line 121 of file AlgExecStateSvc.cpp.

121 {
122
123 return StatusCode::SUCCESS;
124
125 }
StatusCode::SUCCESS
Definition: StatusCode.h:30

unsigned int AlgExecStateSvc::incrementErrorCount | ( | const IAlgorithm * | iAlg | ) |
| override

Definition at line 338 of file AlgExecStateSvc.cpp.

338 {
339 AlgErrorMap_t::iterator itr = m_errorCount.find( iAlg->nameKey() );
340 if (itr != m_errorCount.end()) {
341 return (++(itr->second));
342 } else {
343 error() << "Unable to find Algorithm \"" << iAlg->name() << "\" in map"
344 << " of ErrorCounts" << endmsg;
345 return 0;
346 }
347 }
std::map::end
T end(T...args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
AlgExecStateSvc::m_errorCount
AlgErrorMap_t m_errorCount
Definition: AlgExecStateSvc.h:70
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.
std::map::find
T find(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void AlgExecStateSvc::init | ( |  | ) |
| private

Definition at line 30 of file AlgExecStateSvc.cpp.

30 {
31
32 std::string wbn;
33
34 // seriously? do we have no way of getting a Service by type???
35 std::list<IService*> lst = serviceLocator()->getServices();
36 for (auto &is : lst) {
37 IHiveWhiteBoard *iwb = dynamic_cast<IHiveWhiteBoard*>(is);
38 if (iwb != 0) {
39 wbn = is->name();
40 if (msgLevel(MSG::VERBOSE))
41 verbose() << "HiveWhiteBoard service name is " << wbn << endmsg;
42 break;
43 }
44 }
45
46 SmartIF<IHiveWhiteBoard> wbs;
47 wbs = serviceLocator()->service(wbn,false);
48
49 if (wbs.isValid()) {
50 m_algStates.resize(wbs->getNumberOfStores());
51 m_eventStatus.resize(wbs->getNumberOfStores());
52 } else {
53 m_algStates.resize(1);
54 m_eventStatus.resize(1);
55 }
56
57 if (msgLevel(MSG::DEBUG))
58 debug() << "resizing state containers to : " << m_algStates.size()
59 << endmsg;
60
61 SmartIF<IAlgManager> algMan( serviceLocator() );
62 if (!algMan.isValid()) {
63 fatal() << "could not get the AlgManager" << endmsg;
64 throw GaudiException("In AlgExecStateSvc, unable to get the AlgManager!",
65 "AlgExecStateSvc",StatusCode::FAILURE);
66 }
67
68 m_isInit = true;
69
70 auto algos = algMan->getAlgorithms();
71 for (auto &alg : algos) {
72 addAlg( alg );
73 }
74
75 for (auto &alg : m_preInitAlgs) {
76 addAlg( alg );
77 }
78
79
80 if (msgLevel( MSG::VERBOSE )) {
81 std::ostringstream ost;
82 dump(ost, Gaudi::Hive::currentContext());
83 verbose() << "dumping state:\n" << ost.str() << endmsg;
84 }
85
86 }
SmartIF< IHiveWhiteBoard >
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:23
StatusCode::FAILURE
Definition: StatusCode.h:29
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
CommonMessagingBase::verbose
MsgStream & verbose() const
shortcut for the method msgStream(MSG::VERBOSE)
Definition: CommonMessaging.h:129
MSG::DEBUG
Definition: IMessageSvc.h:18
AlgExecStateSvc::dump
void dump(std::ostringstream &ost, const EventContext &ctx) const override
Definition: AlgExecStateSvc.cpp:130
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
MSG::VERBOSE
Definition: IMessageSvc.h:17
std::vector::resize
T resize(T...args)
std::string
STL class.
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:78
std::ostringstream
STL class.
Gaudi::Hive::currentContext
GAUDI_API const EventContext & currentContext()
Definition: ThreadLocalContext.cpp:24
std::ostringstream::str
T str(T...args)
std::list< IService * >
IHiveWhiteBoard
Definition: IHiveWhiteBoard.h:17
AlgExecStateSvc::m_isInit
bool m_isInit
Definition: AlgExecStateSvc.h:75
std::vector::size
T size(T...args)
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
SmartIF::isValid
bool isValid() const
Allow for check if smart pointer is valid.
Definition: SmartIF.h:62
ISvcLocator::getServices
virtual const std::list< IService * > & getServices() const =0
Get a reference to a service and create it if it does not exists.
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:111
IHiveWhiteBoard::getNumberOfStores
virtual size_t getNumberOfStores() const =0
Get the number of &#39;slots&#39;.
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:292
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
AlgExecStateSvc::addAlg
void addAlg(IAlgorithm *iAlg) override
Definition: AlgExecStateSvc.cpp:154
AlgExecStateSvc::m_preInitAlgs
std::vector< Gaudi::StringKey > m_preInitAlgs
Definition: AlgExecStateSvc.h:67

StatusCode AlgExecStateSvc::initialize | ( |  | ) |
| final override virtual

Definition at line 103 of file AlgExecStateSvc.cpp.

103 {
104
105 // Initialise mother class (read properties, ...)
106 StatusCode sc(Service::initialize());
107 if (!sc.isSuccess()) {
108 warning () << "Base class could not be initialized" << endmsg;
109 return StatusCode::FAILURE;
110 }
111
112 // moved all initialization to init(). hopefully it will get called in time....
113
114 return StatusCode::SUCCESS;
115
116 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode::FAILURE
Definition: StatusCode.h:29
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:120
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void AlgExecStateSvc::reset | ( | const EventContext & | ctx | ) |
| override

Definition at line 293 of file AlgExecStateSvc.cpp.

293 {
294
295 if (msgLevel(MSG::DEBUG))
296 verbose() << "reset(" << ctx.slot() << ")" << endmsg;
297
298 std::call_once(m_initFlag, &AlgExecStateSvc::init, this);
299 for (auto &e : m_algStates.at(ctx.slot())) {
300 e.second.reset();
301 }
302
303 m_eventStatus.at(ctx.slot()) = EventStatus::Invalid;
304
305 }
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::m_algStates
AlgStates_t m_algStates
Definition: AlgExecStateSvc.h:64
AlgExecStateSvc::init
void init()
Definition: AlgExecStateSvc.cpp:30
CommonMessagingBase::verbose
MsgStream & verbose() const
shortcut for the method msgStream(MSG::VERBOSE)
Definition: CommonMessaging.h:129
MSG::DEBUG
Definition: IMessageSvc.h:18
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
AlgExecStateSvc::m_initFlag
std::once_flag m_initFlag
Definition: AlgExecStateSvc.h:74
std::call_once
T call_once(T...args)
std::vector::at
T at(T...args)
EventStatus::Invalid
Definition: IAlgExecStateSvc.h:63
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void AlgExecStateSvc::resetErrorCount | ( | const IAlgorithm * | iAlg | ) |
| override

Definition at line 325 of file AlgExecStateSvc.cpp.

325 {
326 AlgErrorMap_t::iterator itr = m_errorCount.find( iAlg->nameKey() );
327 if (itr != m_errorCount.end()) {
328 itr->second = 0;
329 } else {
330 error() << "Unable to find Algorithm \"" << iAlg->name() << "\" in map"
331 << " of ErrorCounts" << endmsg;
332 }
333 }
std::map::end
T end(T...args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
AlgExecStateSvc::m_errorCount
AlgErrorMap_t m_errorCount
Definition: AlgExecStateSvc.h:70
IAlgorithm::nameKey
virtual const Gaudi::StringKey & nameKey() const =0
StringKey rep of name.
std::map::find
T find(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void AlgExecStateSvc::setEventStatus | ( | const EventStatus::Status & | sc,
|  | const EventContext & | ctx
| ) |  |
| override

Definition at line 267 of file AlgExecStateSvc.cpp.

267 {
268 std::call_once(m_initFlag, &AlgExecStateSvc::init, this);
269 m_eventStatus.at(ctx.slot()) = sc;
270 }
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::init
void init()
Definition: AlgExecStateSvc.cpp:30
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
AlgExecStateSvc::m_initFlag
std::once_flag m_initFlag
Definition: AlgExecStateSvc.h:74
std::call_once
T call_once(T...args)
std::vector::at
T at(T...args)

std::string AlgExecStateSvc::trans | ( | const EventStatus::Status & | sc | ) | const
| private

Definition at line 352 of file AlgExecStateSvc.cpp.

352 {
353 switch (s) {
354 case EventStatus::Invalid :
355 return "Invalid";
356 case EventStatus::Success :
357 return "Success";
358 case EventStatus::AlgFail :
359 return "AlgFail";
360 case EventStatus::AlgStall :
361 return "AlgStall";
362 case EventStatus::Other :
363 return "Other";
364 default :
365 return "Should not happen";
366 }
367
368 }
EventStatus::Other
Definition: IAlgExecStateSvc.h:67
EventStatus::AlgStall
Definition: IAlgExecStateSvc.h:66
EventStatus::Invalid
Definition: IAlgExecStateSvc.h:63
EventStatus::Success
Definition: IAlgExecStateSvc.h:64
EventStatus::AlgFail
Definition: IAlgExecStateSvc.h:65
gaudirun.s
string s
Definition: gaudirun.py:245

void AlgExecStateSvc::updateEventStatus | ( | const bool & | b,
|  | const EventContext & | ctx
| ) |  |
| override

Definition at line 275 of file AlgExecStateSvc.cpp.

275 {
276 std::call_once(m_initFlag, &AlgExecStateSvc::init, this);
277 if (m_eventStatus.at(ctx.slot()) == EventStatus::Success) {
278 if (fail)
279 m_eventStatus.at(ctx.slot()) = EventStatus::AlgFail;
280 } else if (m_eventStatus.at(ctx.slot()) == EventStatus::Invalid) {
281 if (! fail) {
282 m_eventStatus.at(ctx.slot()) = EventStatus::Success;
283 } else {
284 m_eventStatus.at(ctx.slot()) = EventStatus::AlgFail;
285 }
286 }
287 }
EventContext::slot
ContextID_t slot() const
Definition: EventContext.h:41
AlgExecStateSvc::init
void init()
Definition: AlgExecStateSvc.cpp:30
AlgExecStateSvc::m_eventStatus
std::vector< EventStatus::Status > m_eventStatus
Definition: AlgExecStateSvc.h:66
AlgExecStateSvc::m_initFlag
std::once_flag m_initFlag
Definition: AlgExecStateSvc.h:74
std::call_once
T call_once(T...args)
std::vector::at
T at(T...args)
EventStatus::Invalid
Definition: IAlgExecStateSvc.h:63
EventStatus::Success
Definition: IAlgExecStateSvc.h:64
EventStatus::AlgFail
Definition: IAlgExecStateSvc.h:65

## Member Data Documentation

AlgStates_t AlgExecStateSvc::m_algStates
| private

Definition at line 64 of file AlgExecStateSvc.h.

AlgErrorMap_t AlgExecStateSvc::m_errorCount
| private

Definition at line 70 of file AlgExecStateSvc.h.

std::vector< EventStatus::Status > AlgExecStateSvc::m_eventStatus
| private

Definition at line 66 of file AlgExecStateSvc.h.

std::once_flag AlgExecStateSvc::m_initFlag
| private

Definition at line 74 of file AlgExecStateSvc.h.

bool AlgExecStateSvc::m_isInit
| private

Definition at line 75 of file AlgExecStateSvc.h.

std::mutex AlgExecStateSvc::m_mut
| private

Definition at line 77 of file AlgExecStateSvc.h.

std::vector< Gaudi::StringKey > AlgExecStateSvc::m_preInitAlgs
| private

Definition at line 67 of file AlgExecStateSvc.h.

The documentation for this class was generated from the following files:

- GaudiCoreSvc/src/AlgExecStateSvc/AlgExecStateSvc.h
- GaudiCoreSvc/src/AlgExecStateSvc/AlgExecStateSvc.cpp